(*
    ===========================================================================

    Main.pas

    ===========================================================================
*)
unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ExtCtrls, StdCtrls, iDragDrop, iFont,
  ImgList, Buttons, ComCtrls, IniFiles, ToolWin;

type
    TCallbackLoopProc = function(Item: TFontFile; Data: integer): Boolean;

type
  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    MenuFile: TMenuItem;
    MenuExit: TMenuItem;
    MenuInfo: TMenuItem;
    ImageList: TImageList;
    PnlMain: TPanel;
    Page: TPageControl;
    TabFont: TTabSheet;
    TabKana: TTabSheet;
    PopupMark: TPopupMenu;
    MenuMarkUsage: TMenuItem;
    MenuMarkWhite: TMenuItem;
    MenuMarkGray: TMenuItem;
    MenuMarkRed: TMenuItem;
    MenuMarkYellow: TMenuItem;
    MenuMarkGreen: TMenuItem;
    MenuMarkCyan: TMenuItem;
    MenuMarkBlue: TMenuItem;
    MenuMarkMagenda: TMenuItem;
    MenuOpenAsIs: TMenuItem;
    MenuProperty: TMenuItem;
    MenuDirectory: TMenuItem;
    N1: TMenuItem;
    MenuJunkClash: TMenuItem;
    MenuFont: TMenuItem;
    MenuUninsAll: TMenuItem;
    N2: TMenuItem;
    MenuShowHint: TMenuItem;
    MemoKana: TMemo;
    MenuList: TMenuItem;
    MenuListWhite: TMenuItem;
    MenuListGray: TMenuItem;
    MenuListRed: TMenuItem;
    MenuListYellow: TMenuItem;
    MenuListGreen: TMenuItem;
    MenuListCyan: TMenuItem;
    MenuListBlue: TMenuItem;
    MenuListMagenda: TMenuItem;
    MenuClearAll: TMenuItem;
    MenuMisc: TMenuItem;
    MenuMarkClear: TMenuItem;
    MenuTryAsIs: TMenuItem;
    LB: TListBox;
    Pnl00: TPanel;
    BtnInstall: TBitBtn;
    BtnUninst: TBitBtn;
    BtnDelete: TBitBtn;
    BtnTrash: TBitBtn;
    BtnSortStat: TBitBtn;
    BtnSortMark: TBitBtn;
    BtnSortName: TBitBtn;
    MemoMsg: TMemo;
    Splitter1: TSplitter;
    Pnl01: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ComboFonts: TComboBox;
    CmbKana: TComboBox;
    TrackSize01: TTrackBar;
    BtnAddHistory: TBitBtn;
    BtnRmvHistory: TBitBtn;
    TabStep: TTabSheet;
    N3: TMenuItem;
    Pnl03: TPanel;
    EdtFontName: TEdit;
    LblAlready: TLabel;
    LblFailed: TLabel;
    LblTemp: TLabel;
    Label7: TLabel;
    MemSample: TMemo;
    ToolPostIt: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    TbNone: TToolButton;
    SbPrev: TSpeedButton;
    SbNext: TSpeedButton;
    Pnl03Btm: TPanel;
    TrackSize02: TTrackBar;
    CmbCharSet: TComboBox;
    procedure MenuInfoClick(Sender: TObject);
    procedure MenuExitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MenuPROPERTYClick(Sender: TObject);
    procedure MenuOPENASISClick(Sender: TObject);
    procedure MenuDIRECTORYClick(Sender: TObject);
    procedure LBDrawItem(Control: TWinControl; Index: Integer; Rect: TRect;
      State: TOwnerDrawState);
    procedure LBData(Control: TWinControl; Index: Integer;
      var Data: String);
    procedure BtnInstallClick(Sender: TObject);
    procedure BtnUninstClick(Sender: TObject);
    procedure BtnDeleteClick(Sender: TObject);
    procedure MenuJunkClashClick(Sender: TObject);
    procedure BtnSortNameClick(Sender: TObject);
    procedure BtnSortStatClick(Sender: TObject);
    procedure BtnSortMarkClick(Sender: TObject);
    procedure MenuUninsAllClick(Sender: TObject);
    procedure MenuMarkMagendaClick(Sender: TObject);
    procedure MenuShowHintClick(Sender: TObject);
    procedure MenuFontClick(Sender: TObject);
    procedure PageChange(Sender: TObject);
    procedure ComboFontsChange(Sender: TObject);
    procedure CmbKanaChange(Sender: TObject);
    procedure MenuClearAllClick(Sender: TObject);
    procedure MenuListMagendaClick(Sender: TObject);
    procedure CmbKanaKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BtnAddHistoryClick(Sender: TObject);
    procedure MenuMarkUsageClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure MenuTryAsIsClick(Sender: TObject);
    procedure BtnRmvHistoryClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MenuMarkClearClick(Sender: TObject);
    procedure SbPrevClick(Sender: TObject);
    procedure SbNextClick(Sender: TObject);
    procedure PageChanging(Sender: TObject; var AllowChange: Boolean);
    procedure ToolButton1Click(Sender: TObject);
    procedure TrackSize02Change(Sender: TObject);
  private
    FIniFile    : TIniFile;

    Dropper     : TShellDrop;
    Bitmap      : TBitmap;
    WorkSL      : TStringList;

    FFontList   : TFontFileList;
    PreListFile : string;

    FDispAsIs   : Boolean;

    FCheckFontIndex: integer;
    FTemporaryInstall: Boolean;

    procedure   CreateMember();
    procedure   DestroyMember();
    procedure   LoadSetting();
    procedure   SaveSetting();
    procedure   ShowMsg(const AMsg: string);
    procedure   DroppedAction(AFiles, AFolds: TStringList;
                            AControl: TControl; APos: TPoint);
    procedure   AppShowHint(var HintStr: string;
                            var CanShow: Boolean; var HintInfo: THintInfo);

    procedure   SetLbCount();
    procedure   ListBoxSelectedItemLoop(ALB: TListBox; AProc: TCallbackLoopProc; Data: integer);
    procedure   ListBoxFullItemLoop(ALB: TListBox; AProc: TCallbackLoopProc; Data: integer);
    procedure   ListBoxSelectItemLoop(ALB: TListBox; AProc: TCallbackLoopProc; Data: integer);
    function    GetCurrentListFile(): string;

    procedure   FontAssignKana();

    procedure   DispCheckFont();
    procedure   PrevCheckFont();
    procedure   NextCheckFont();
    procedure   BuildCharSetChoice();
    procedure   FontAssignStep();
  public

  end;

var
    MainForm: TMainForm;

const
    //  F
    GC_NONCELLAREA = TColor($00EEEEEE);     //  ͈͊O̐F

    GC_BG_EMPTY    = TColor($00CCCCCC);     //  ZwiF
    GC_BG_FOCUSED  = TColor($00F0CAA6);     //  tH[JXZwiF
    GC_BG_SELECT   = TColor($00F0CAFF);     //  IZwiF
    GC_BG_NORMAL   = TColor($00F0FBFF);     //  ʏZwiF

    GC_FG_FOCUSED  = TColor($000000);       //  tH[JXZF
    GC_FG_SELECT   = TColor($000000);       //  IZF
    GC_FG_NORMAL   = TColor($000000);       //  ʏZF

procedure   SimpleMessage(AMsg: string);
function    SimpleYesNo(AMsg: string): Boolean;

implementation

uses
    Info, iFiles, ScanFile;

{$R *.dfm}

(*
    ===========================================================================
    񃁃bZ[W_CAO
    ===========================================================================
*)
procedure   SimpleMessage(AMsg: string);
var
    Dialog: TForm;
    Image : TImage;
begin
    Application.NormalizeTopMosts;

    Dialog := CreateMessageDialog(AMsg, mtInformation, [mbOK]);
    try
        Image := TImage(Dialog.FindComponent('Image'));
        if (Image <> nil) then Image.Picture.Icon.Assign(Application.Icon);
        Dialog.ShowModal;
    finally
        Dialog.Free;
    end;
    
    Application.RestoreTopMosts;
end;

(*
    ===========================================================================
    mFbZ[W_CAO
    ===========================================================================
*)
function    SimpleYesNo(AMsg: string): Boolean;
var
    Dialog: TForm;
    Image : TImage;
begin
    Application.NormalizeTopMosts;

    Dialog := CreateMessageDialog(AMsg, mtInformation, [mbYes, mbNo]);
    try
        Image := TImage(Dialog.FindComponent('Image'));
        if (Image <> nil) then Image.Picture.Icon.Assign(Application.Icon);
        Result := (Dialog.ShowModal = mrYes);
    finally
        Dialog.Free;
    end;
    
    Application.RestoreTopMosts;
end;

(*
    ****************************************************************************

    COMMON

    ****************************************************************************
*)

(*
    =================================================================
    [2004/03/08]o[쐬
    =================================================================
*)
procedure   TMainForm.CreateMember();
begin
    FIniFile := TIniFile.Create(ChangeFileExt(ParamStr(0), '.ini'));

    WorkSL := TStringList.Create;

    Bitmap := TBitmap.Create;
    Bitmap.Height := LB.ItemHeight;
    Bitmap.Width := Screen.Width;
    Bitmap.Canvas.Font.Assign(Self.Font);

    FFontList := TFontFileList.Create;
    FFontList.LiveMsgProc := ShowMsg;

    Dropper := TShellDrop.Create(LB, DroppedAction);
    Dropper.Start();
end;

(*
    =================================================================
    [2004/03/08]o[j
    =================================================================
*)
procedure   TMainForm.DestroyMember();
begin
    FFontList.Free;
    Dropper.Free;
    Bitmap.Free;
    WorkSL.Free;
    FIniFile.Free;
end;

(*
    =================================================================
    [2004/03/08]ݒǍ
    =================================================================
*)
procedure   TMainForm.LoadSetting();
var
    i: integer;
    MenuTemp: TMenuItem;
    NotCheck: Boolean;
begin
    //  ʒu
    Self.Left   := FIniFIle.ReadInteger(Self.Name, 'Left'  , Self.Left);
    Self.Top    := FIniFIle.ReadInteger(Self.Name, 'Top'   , Self.Top);
    Self.Width  := FIniFIle.ReadInteger(Self.Name, 'Width' , Self.Width);
    Self.Height := FIniFIle.ReadInteger(Self.Name, 'Height', Self.Height);
    //  j[̃`FbN
    MenuTemp := MenuShowHint;
    MenuTemp.Checked := FIniFIle.ReadBool(MenuTemp.Name, 'Checked', MenuTemp.Checked);
    MenuTemp.OnClick(MenuTemp);
    //  j[̃`FbN
    FDispAsIs := false;
    MenuTemp := MenuTryAsIs;
    MenuTemp.Checked := FIniFIle.ReadBool(MenuTemp.Name, 'Checked', MenuTemp.Checked);
    MenuTemp.OnClick(MenuTemp);
    //  샊Xg
    NotCheck := true;
    for i := 0 to MenuList.Count - 1 do
    begin
        MenuTemp := MenuList.Items[i];
        MenuTemp.Caption := FIniFIle.ReadString(MenuTemp.Name, 'Caption', MenuTemp.Caption);
        MenuTemp.Checked := FIniFIle.ReadBool(MenuTemp.Name, 'Checked', MenuTemp.Checked);
        if MenuTemp.Checked then NotCheck := false;
    end;
    //  `FbNĂȂ
    if NotCheck then MenuListWhite.Checked := true;
    //  
    for i := 0 to PopupMark.Items.Count - 1 do
    begin
        MenuTemp := PopupMark.Items[i];
        MenuTemp.Caption := FIniFIle.ReadString(MenuTemp.Name, 'Caption', MenuTemp.Caption);
    end;
    //  Ǎ
    PreListFile := GetCurrentListFile();
    FFontList.LoadFromFile(PreListFile);
    SetLbCount();
    if (FFontList.Count > 0) then LB.Selected[0] := true;
end;

(*
    =================================================================
    [2004/03/08]ݒۑ
    =================================================================
*)
procedure   TMainForm.SaveSetting();
var
    i: integer;
    MenuTemp: TMenuItem;
begin
    FIniFIle.WriteInteger(Self.Name, 'Left'  , Self.Left);
    FIniFIle.WriteInteger(Self.Name, 'Top'   , Self.Top);
    FIniFIle.WriteInteger(Self.Name, 'Width' , Self.Width);
    FIniFIle.WriteInteger(Self.Name, 'Height', Self.Height);
    //  `FbN󋵂L^
    MenuTemp := MenuShowHint;
    FIniFIle.WriteBool(MenuTemp.Name, 'Checked', MenuTemp.Checked);
    MenuTemp := MenuTryAsIs;
    FIniFIle.WriteBool(MenuTemp.Name, 'Checked', MenuTemp.Checked);
    //  IĂ郊XgL^
    for i := 0 to MenuList.Count - 1 do
    begin
        MenuTemp := MenuList.Items[i];
        FIniFIle.WriteString(MenuTemp.Name, 'Caption', MenuTemp.Caption);
        FIniFIle.WriteBool(MenuTemp.Name, 'Checked', MenuTemp.Checked);
    end;
    //  
    for i := 0 to PopupMark.Items.Count - 1 do
    begin
        MenuTemp := PopupMark.Items[i];
        FIniFIle.ReadString(MenuTemp.Name, 'Caption', MenuTemp.Caption);
    end;
end;

(*
    =================================================================
    tH[RXgN^
    =================================================================
*)
procedure TMainForm.FormCreate(Sender: TObject);
begin
    //  ^Cgݒ
    Self.Caption := Application.Title + '-' + Self.Caption;
    //  Fݒ
    LB.Color := GC_NONCELLAREA;
    //  qg\JX^}CY
    Application.OnShowHint := AppShowHint;
    //  y[Wݒ
    Page.ActivePageIndex := 0;
    //  o[쐬
    CreateMember();
    //  CharSetI쐬
    BuildCharSetChoice();
    //  ݒǍ
    LoadSetting();
end;

(*
    =================================================================
    tH[fXgN^
    =================================================================
*)
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    //  ۑ
    FFontList.SaveToFile(GetCurrentListFile());
    //  ݒۑ
    SaveSetting();
    //  o[j
    DestroyMember();
    //  qg\߂
    Application.OnShowHint := nil;
end;

(*
    ===========================================================================
    bZ[W\
    ===========================================================================
*)
procedure   TMainForm.ShowMsg(const AMsg: string);
var
    TimeStr: string;
begin
    if MemoMsg.Lines.Count > 100 then MemoMsg.Lines.Delete(0);
    TimeStr := FormatDateTime('hh:nn:ss" :"', Now);
    MemoMsg.Lines.Add(Format('%s%s', [TimeStr, AMsg]));
end;

(*
    =================================================================
    y[W؂ւ
    =================================================================
*)
procedure TMainForm.PageChange(Sender: TObject);
var
    Index: integer;
begin
    //  C
    if TPageControl(Sender).ActivePageIndex = 0 then
    begin
        MenuFile.Enabled := true;
        MenuFont.Enabled := true;
        MenuList.Enabled := true;
        MenuMisc.Enabled := true;
    end
    else
    //  
    if TPageControl(Sender).ActivePageIndex = 1 then
    begin
        MenuFile.Enabled := false;
        MenuFont.Enabled := false;
        MenuList.Enabled := false;
        MenuMisc.Enabled := false;

        GetScreenFonts(ComboFonts.Items);
        Index := ComboFonts.Items.IndexOf(MemoKana.Font.Name);
        if (Index <> -1) then
        begin
            ComboFonts.ItemIndex := Index;
        end;
        FontAssignKana();
    end
    else
    //  Xebv`FbN
    if TPageControl(Sender).ActivePageIndex = 2 then
    begin
        MenuFile.Enabled := false;
        MenuFont.Enabled := false;
        MenuList.Enabled := false;
        MenuMisc.Enabled := false;

        FCheckFontIndex := 0;
        FTemporaryInstall := false;
        SbPrev.Enabled := (LB.Count > 0);
        SbNext.Enabled := (LB.Count > 0);
        ToolPostIt.Enabled := (LB.Count > 0);
        FontAssignStep();
        EdtFontName.Clear();
        if (LB.Count > 0) then DispCheckFont();
    end;
end;

(*
    ****************************************************************************

    PAGE-00

    ****************************************************************************
*)

(*
    =================================================================
    [2004/03/01]Ǝ̃qg\
    -----------------------------------------------------------------
    http://www.din.or.jp/~egawa-n/delphi/tips/grid_hint.html
    =================================================================
*)
procedure   TMainForm.AppShowHint(var HintStr: string;
  var CanShow: Boolean; var HintInfo: THintInfo);
var
    Index: Integer;
begin
    if HintInfo.HintControl = LB then
    begin
        Index := LB.ItemAtPos(HintInfo.CursorPos, true);
        if (Index <> -1) then
        begin
            HintStr := FFontList.GetItem(Index).FileHint;
            HintInfo.CursorRect := LB.ItemRect(Index);
            CanShow := (HintInfo.CursorPos.x < HintInfo.CursorRect.Right) and
                       (HintInfo.CursorPos.y < HintInfo.CursorRect.Bottom);
        end
        else
        begin
            HintStr := LB.Hint;
        end;
        HintInfo.ReshowTimeout := 1000
    end;
end;

(*
    =================================================================
    [2004/03/01]
    Xg{bNX̑IꂽCfbNXɑΉTFontFIle
    IuWFNg֐ɓnĂ
    =================================================================
*)
procedure   TMainForm.ListBoxSelectedItemLoop(ALB: TListBox; AProc: TCallbackLoopProc; Data: integer);
var
    i: integer;
    Rect: TRect;
begin
    for i := 0 to ALB.Count - 1 do
    begin
        if (not ALB.Selected[i]) then continue;
        AProc(FFontList.GetItem(i), Data);
        Rect := ALB.ItemRect(i);
        InvalidateRect(ALB.Handle, @Rect, false);
        ALB.Update();
    end;
end;

(*
    =================================================================
    [2004/03/01]
    Xg{bNX̑SẴACeɑΉTFontFIle
    IuWFNg֐ɓnĂ
    =================================================================
*)
procedure   TMainForm.ListBoxFullItemLoop(ALB: TListBox; AProc: TCallbackLoopProc; Data: integer);
var
    i: integer;
    Rect: TRect;
begin
    for i := 0 to ALB.Count - 1 do
    begin
        AProc(FFontList.GetItem(i), Data);
        Rect := ALB.ItemRect(i);
        InvalidateRect(ALB.Handle, @Rect, false);
        ALB.Update();
    end;
end;

(*
    =================================================================
    [2004/03/01]
    Xg{bNX̑SẴACeɑΉTFontFIleIuWFNg
    ֐ɓnĂA߂lɂđIԂύX
    =================================================================
*)
procedure   TMainForm.ListBoxSelectItemLoop(ALB: TListBox; AProc: TCallbackLoopProc; Data: integer);
var
    i: integer;
    Rect: TRect;
begin
    for i := 0 to ALB.Count - 1 do
    begin
        ALB.Selected[i] := AProc(FFontList.GetItem(i), Data);
        Rect := ALB.ItemRect(i);
        InvalidateRect(ALB.Handle, @Rect, false);
        ALB.Update();
    end;
end;

(*
    =================================================================
    Z`
    =================================================================
*)
procedure TMainForm.LBDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
    PreFontName: string;
    FontFile: TFontFile;
    BitmapRect: TRect;
    TextHeight: integer;
    ImgOffsetX, ImgOffsetY: integer;
    OffsetX, OffsetY: integer;
    CellText: string;
    PostItIndex: integer;
begin
    FontFile := FFontList.GetItem(Index);
    PostItIndex := Ord(FontFile.PostIt);
    CellText := LB.Items[Index];

    //  tH[JXZ
    if (odFocused in State) then
    begin
        Bitmap.Canvas.Brush.Color := GC_BG_FOCUSED;
        Bitmap.Canvas.Font.Color  := GC_FG_FOCUSED;
    end
    else
    //  IZ
    if (odSelected in State) then
    begin
        Bitmap.Canvas.Brush.Color := GC_BG_SELECT;
        Bitmap.Canvas.Font.Color  := GC_FG_SELECT;
    end
    else
    //  ʏZ
    begin
        Bitmap.Canvas.Brush.Color := GC_BG_NORMAL;
        Bitmap.Canvas.Font.Color  := GC_FG_NORMAL;
    end;

    //  lϊ
    BitmapRect := Bounds(0, 0, Rect.Right - Rect.Left, Rect.Bottom - Rect.Top);
    TextHeight := Bitmap.Canvas.TextHeight(CellText);

    //  ItZbgvZ
    ImgOffsetX := 5;
    ImgOffsetY := (BitmapRect.Bottom - ImageList.Height) div 2; 

    //  ItZbgvZ
    OffsetY := (BitmapRect.Bottom - TextHeight) div 2;
    OffsetX := ImgOffsetX + ImageList.Width + 5;

    //  Bitmapɕ`
    PreFontName := Bitmap.Canvas.Font.Name;
    if FDispAsIs then
        Bitmap.Canvas.Font.Name := FontFile.GetAddedFontName(PreFontName);
    Bitmap.Canvas.TextRect(BitmapRect, OffsetX, OffsetY, CellText);
    Bitmap.Canvas.Font.Name := PreFontName;

    if (PostItIndex <> -1) then
    begin
        ImageList.Draw(Bitmap.Canvas, ImgOffsetX, ImgOffsetY, PostItIndex);
    end;

    //  {̂ɕ`
    BitBlt(LB.Canvas.Handle, Rect.Left, Rect.Top, BitmapRect.Right, BitmapRect.Bottom,
        Bitmap.Canvas.Handle, 0, 0, SRCCOPY)
end;

procedure TMainForm.LBData(Control: TWinControl; Index: Integer;
  var Data: String);
begin
    Data := (FFontList.GetItem(Index).DispName);
    Data := Format('%3.3d %s', [Index, Data]);
end;

(*
    ===========================================================================
    tHghbv
    ===========================================================================
*)
procedure   TMainForm.DroppedAction(AFiles, AFolds: TStringList;
            AControl: TControl; APos: TPoint);
var
	i: integer;
begin
    ScanFiles(FONT_EXT, AFiles, AFolds, nil, WorkSL);
    for i := 0 to WorkSL.Count - 1 do
    begin
        FFontList.AddFontFile(WorkSL[i]);
    end;
    SetLbCount();
end;

(*
    ===========================================================================
    Xg{bNXsݒ
    ===========================================================================
*)
procedure   TMainForm.SetLbCount();
begin
    LB.Count := FFontList.Count;
    LB.Repaint;
end;

(*
    ===========================================================================
    [2004/03/01]CXg[
    ===========================================================================
*)
    function    _Install(Item: TFontFile; Data: integer): Boolean;
    begin
        Result := Item.Install();
    end;

procedure TMainForm.BtnInstallClick(Sender: TObject);
begin
    ListBoxSelectedItemLoop(LB, _Install, 0);
end;

(*
    ===========================================================================
    [2004/03/01]ACXg[
    ===========================================================================
*)
    function    _UnInstall(Item: TFontFile; Data: integer): Boolean;
    begin
        if Item.Installed then Item.UnInstall();
        Result := true;
    end;

procedure TMainForm.BtnUninstClick(Sender: TObject);
begin
    ListBoxSelectedItemLoop(LB, _UnInstall, 0);
end;

(*
    ===========================================================================
    [2004/03/01]Xg珜
    ===========================================================================
*)
procedure TMainForm.BtnDeleteClick(Sender: TObject);
var
    i: integer;
begin
    //  Ƃ肠ACXg[
    ListBoxSelectedItemLoop(LB, _UnInstall, 0);

    //  IACe
    for i := LB.Count - 1 downto 0 do
    begin
        if (not LB.Selected[i]) then continue;
        FFontList.Delete(i);
    end;

    //  sݒ
    SetLbCount();
end;

(*
    =================================================================
    t@C̃vpeB\
    =================================================================
*)
procedure TMainForm.MenuPROPERTYClick(Sender: TObject);
var
    Index: integer;
begin
    Index := LB.ItemIndex;
    if Index <> -1 then FFontList.GetItem(Index).OpenProperty();
end;

(*
    =================================================================
    ܂܂ĂtH_J
    =================================================================
*)
procedure TMainForm.MenuDIRECTORYClick(Sender: TObject);
var
    Index: integer;
begin
    Index := LB.ItemIndex;
    if Index <> -1 then FFontList.GetItem(Index).OpenParentDir();
end;

(*
    =================================================================
    GNXv[Ń_uNbN󋵂ɂ
    =================================================================
*)
procedure TMainForm.MenuOPENASISClick(Sender: TObject);
var
    Index: integer;
begin
    Index := LB.ItemIndex;
    if Index <> -1 then FFontList.GetItem(Index).OpenAsIs();
end;

(*
    =================================================================
    ŏčő剻
    =================================================================
*)
procedure TMainForm.MenuJunkClashClick(Sender: TObject);
begin
    Application.Minimize();
    Application.Restore();
end;

(*
    =================================================================
    \[g-1
    =================================================================
*)
procedure TMainForm.BtnSortNameClick(Sender: TObject);
begin
    FFontList.SortBy(ffstName);
    LB.Repaint;
end;

(*
    =================================================================
    \[g-2
    =================================================================
*)
procedure TMainForm.BtnSortStatClick(Sender: TObject);
begin
    FFontList.SortBy(ffstInstalled);
    LB.Repaint;
end;

(*
    =================================================================
    \[g-3
    =================================================================
*)
procedure TMainForm.BtnSortMarkClick(Sender: TObject);
begin
    FFontList.SortBy(ffstMark);
    LB.Repaint;
end;

(*
    =================================================================
    AboutBox
    =================================================================
*)
procedure TMainForm.MenuInfoClick(Sender: TObject);
begin
    OpenInfoForm();
end;

(*
    =================================================================
    [2004/03/01]SACXg[
    =================================================================
*)
procedure TMainForm.MenuUninsAllClick(Sender: TObject);
begin
    ListBoxFullItemLoop(LB, _UnInstall, 0);
end;

(*
    =================================================================
    [2004/03/04]}[LOƂ
    =================================================================
*)
    //  }[N
    function    _Marking(Item: TFontFile; Data: integer): Boolean;
    begin
        Item.PostIt := TPostIt(Data);
        Result := true;
    end;
    //  }[NőI
    function    _SelectByMark(Item: TFontFile; Data: integer): Boolean;
    begin
        Result := (Item.PostIt = TPostIt(Data));
    end;
    //  }[NŃCXg[
    function    _InstallByMark(Item: TFontFile; Data: integer): Boolean;
    begin
        Result := (Item.PostIt = TPostIt(Data));
        if Result then Result := Item.Install();
    end;
    //  }[NŃACXg[
    function    _UnInstallByMark(Item: TFontFile; Data: integer): Boolean;
    begin
        Result := (Item.PostIt = TPostIt(Data));
        if Result then if Item.Installed then Item.Uninstall();
    end;

procedure TMainForm.MenuMarkMagendaClick(Sender: TObject);
var
    SftPressed, CtrlPressed: Boolean;
    Mark: TPostIt;
begin
    SftPressed  := (GetAsyncKeyState(VK_SHIFT) < 0);
    CtrlPressed := (GetAsyncKeyState(VK_CONTROL) < 0);

    Mark := TPostIt(TMenuItem(Sender).ImageIndex);

    if (SftPressed and CtrlPressed) then
    begin
        ListBoxFullItemLoop(LB, _UnInstallByMark, Integer(Mark));
    end
    else
    if SftPressed then
    begin
        ListBoxSelectItemLoop(LB, _SelectByMark, Integer(Mark));
    end
    else
    if CtrlPressed then
    begin
        ListBoxFullItemLoop(LB, _InstallByMark, Integer(Mark));
    end
    else
    begin
        ListBoxSelectedItemLoop(LB, _Marking, Integer(Mark));
    end;
end;

(*
    =================================================================
    [2004/03/04]|bvAbv̎g
    =================================================================
*)
procedure TMainForm.MenuMarkUsageClick(Sender: TObject);
var
    Msg: string;
begin
    Msg := 'Marking'#9#9'Click'#13#10
        +  'Select'#9#9'[SHIFT]+Click'#13#10
        +  'Install'#9#9'[CTRL]+Click'#13#10
        +  'Uninstall'#9'[SHIFT]+[CTRL]+Click';
    SimpleMessage(Msg);
end;

(*
    =================================================================
    I
    =================================================================
*)
procedure TMainForm.MenuExitClick(Sender: TObject);
begin
    Self.Close();
end;

(*
    =================================================================
    [2004/03/01]qg\
    =================================================================
*)
procedure TMainForm.MenuShowHintClick(Sender: TObject);
begin
    Self.ShowHint := TMenuItem(Sender).Checked;
end;

(*
    =================================================================
    [2004/03/05]tHg\
    =================================================================
*)
procedure TMainForm.MenuTryAsIsClick(Sender: TObject);
begin
    FDispAsIs := TMenuItem(Sender).Checked;
    LB.Repaint();
end;


(*
    =================================================================
    [2004/03/01]GNXv[ł̑
    =================================================================
*)
procedure TMainForm.MenuFontClick(Sender: TObject);
var
    IsOneSelected: Boolean;
    ItemExists: Boolean;
begin
    //  1̂ݑIn
    IsOneSelected := (LB.SelCount = 1);
    MenuOpenAsIs.Enabled  := IsOneSelected;
    MenuProperty.Enabled  := IsOneSelected;
    MenuDirectory.Enabled := IsOneSelected;

    //  ̑
    ItemExists := (LB.Count > 0);
    MenuUninsAll.Enabled := ItemExists;
    MenuClearAll.Enabled := ItemExists;
end;

(*
    =================================================================
    [2004/03/02]SNA
    =================================================================
*)
procedure TMainForm.MenuClearAllClick(Sender: TObject);
begin
    if not SimpleYesNo('Really?') then Exit;
    //  ACXg[
    ListBoxFullItemLoop(LB, _UnInstall, 0);
    //  NA
    FFontList.Clear();
    SetLbCount();
end;

(*
    =================================================================
    [2004/03/08]݂̃tHgꗗێt@C
    =================================================================
*)
function    TMainForm.GetCurrentListFile(): string;
var
    i: integer;
    MenuItem: TMenuItem;
begin
    MenuItem := MenuListWhite;
    for i := 0 to MenuList.Count - 1 do
    begin
        MenuItem := MenuList.Items[i];
        if MenuItem.Checked then break;
    end;
    Result := ChangeFileExt(ParamStr(0), MenuItem.Name + '.dat');
end;

(*
    =================================================================
    [2004/03/02]t@C؂ւ
    =================================================================
*)
procedure TMainForm.MenuListMagendaClick(Sender: TObject);
var
    Temp: string;
begin
    //  Vt@C擾
    Temp := GetCurrentListFile();
    //  Ă
    if (Temp <> PreListFile) then
    begin
        //  ۑ
        FFontList.SaveToFile(PreListFile);
        //  ACXg[
        ListBoxFullItemLoop(LB, _UnInstall, 0);
        //  NA
        FFontList.Clear();
        //  Vt@CZbg
        PreListFile := Temp;
        //  Ǎ
        FFontList.LoadFromFile(PreListFile);
        //  sݒ
        SetLbCount();
        if (FFontList.Count > 0) then LB.Selected[0] := true;
    end;
end;

(*
    =================================================================
    [2004/03/05]IO
    =================================================================
*)
procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
    //  ACXg[
    MenuUninsAllClick(MenuUninsAll);
end;

(*
    =================================================================
    [2004/03/08]ESCŕ
    =================================================================
*)
procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if (Key = VK_ESCAPE) then Self.Close();
end;

(*
    =================================================================
    [2004/03/09]}[NNA
    =================================================================
*)
    //  }[NNA
    function    _ClearMark(Item: TFontFile; Data: integer): Boolean;
    begin
        Item.PostIt := piNone;
        Result := false;
    end;

procedure TMainForm.MenuMarkClearClick(Sender: TObject);
begin
    ListBoxSelectedItemLoop(LB, _ClearMark, 0);
end;

(*
    ****************************************************************************

    PAGE-01

    ****************************************************************************
*)

(*
    =================================================================
    tHgf
    =================================================================
*)
procedure   TMainForm.FontAssignKana();
begin
    if (ComboFonts.ItemIndex <> -1) then
    begin
        MemoKana.Font.Name := ComboFonts.Text;
    end;
    try
        MemoKana.Font.Size := TrackSize01.Position;
    except
        ;
    end;
end;


(*
    =================================================================
    tHgύX
    =================================================================
*)
procedure TMainForm.ComboFontsChange(Sender: TObject);
begin
    FontAssignKana();
end;

(*
    =================================================================
    ύX
    =================================================================
*)
procedure TMainForm.CmbKanaChange(Sender: TObject);
begin
	MemoKana.Text := KanaToChars(CmbKana.Text);
end;

(*
    =================================================================
    pJim薳Œړ͂
    http://www2.big.or.jp/~osamu/Delphi/Tips/key.cgi?key=0#0160.txt
    =================================================================
*)
procedure TMainForm.CmbKanaKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
type
  TLetters = set of 'A'..'z';
const
  Vowels: TLetters = ['A', 'E', 'I', 'O', 'U', 'a', 'e', 'i', 'o', 'u'];
begin
  if (Key<>VK_RETURN) and (Chr(Key) in Vowels) then
  begin
    Keybd_event(VK_RETURN,0,0,0);
    Keybd_event(VK_RETURN,0,KEYEVENTF_KEYUP,0);
  end;
end;

(*
    =================================================================
    ɒǉ
    =================================================================
*)
procedure TMainForm.BtnAddHistoryClick(Sender: TObject);
var
    Str: string;
begin
    Str := Trim(CmbKana.Text);
    if (Str <> '') and (CmbKana.Items.IndexOf(Str) = -1) then
    begin
        CmbKana.Items.Insert(0, Str);
    end;
    CmbKana.SetFocus();
end;

(*
    =================================================================
    폜
    =================================================================
*)
procedure TMainForm.BtnRmvHistoryClick(Sender: TObject);
var
    Index: integer;
begin
    Index := CmbKana.ItemIndex;
    if (Index <> -1) then
    begin
        CmbKana.Items.Delete(Index);
        Dec(Index);
        if (Index > -1) then CmbKana.ItemIndex := Index;
    end;
    CmbKana.SetFocus();
end;

(*
    ****************************************************************************

    PAGE-02

    ****************************************************************************
*)

(*
    =================================================================
    tHgf
    =================================================================
*)
procedure   TMainForm.FontAssignStep();
begin
    MemSample.Font.Size := TrackSize02.Position;
    MemSample.Font.Charset := TFontCharset(CmbCharSet.Items.Objects[CmbCharSet.ItemIndex]);
end;

(*
    =================================================================
    [2004/03/10]CharSetI쐬
    =================================================================
*)
const
    COUNT_HARSET = 17;

    FONT_CHARSETS: array[0..COUNT_HARSET-1] of TFontCharset
    = (
        ANSI_CHARSET     , DEFAULT_CHARSET   , SYMBOL_CHARSET , MAC_CHARSET       ,
        SHIFTJIS_CHARSET , HANGEUL_CHARSET   , JOHAB_CHARSET  , GB2312_CHARSET    ,
        TURKISH_CHARSET  , VIETNAMESE_CHARSET, HEBREW_CHARSET , ARABIC_CHARSET    ,
        BALTIC_CHARSET   , RUSSIAN_CHARSET   , THAI_CHARSET   , EASTEUROPE_CHARSET,
        OEM_CHARSET
        );
    FONT_CHARSETS_STR: array[0..COUNT_HARSET-1] of string
    = (
        'ANSI_CHARSET'     , 'DEFAULT_CHARSET'   , 'SYMBOL_CHARSET' , 'MAC_CHARSET'       ,
        'SHIFTJIS_CHARSET' , 'HANGEUL_CHARSET'   , 'JOHAB_CHARSET'  , 'GB2312_CHARSET'    ,
        'TURKISH_CHARSET'  , 'VIETNAMESE_CHARSET', 'HEBREW_CHARSET' , 'ARABIC_CHARSET'    ,
        'BALTIC_CHARSET'   , 'RUSSIAN_CHARSET'   , 'THAI_CHARSET'   , 'EASTEUROPE_CHARSET',
        'OEM_CHARSET'
        );

procedure   TMainForm.BuildCharSetChoice();
var
    i: integer;
begin
    for i := 0 to COUNT_HARSET - 1 do
    begin
        CmbCharSet.Items.AddObject(FONT_CHARSETS_STR[i], TObject(FONT_CHARSETS[i]));
    end;
    CmbCharSet.ItemIndex := 1;
end;

(*
    =================================================================
    [2004/03/09]y[W؂ւO
    =================================================================
*)
procedure TMainForm.PageChanging(Sender: TObject;
  var AllowChange: Boolean);
var
    Item: TFontFile;
begin
    if (Page.ActivePageIndex = 2) then
    begin
        //  `FbNpɃCXg[Ă
        if FTemporaryInstall then
        begin
            //  ЕtĂ
            Item := FFontList.GetItem(FCheckFontIndex);
            Item.UnInstall();
            FTemporaryInstall := false;
        end;
    end;
end;

(*
    =================================================================
    tHg\
    =================================================================
*)
procedure   TMainForm.DispCheckFont();
var
    Item: TFontFile;
begin
    Item := FFontList.GetItem(FCheckFontIndex);
    EdtFontName.Text := Item.FileName;

    //  CXg[ς݂̏ꍇ
    if (Item.Installed) then
    begin
        //  tHgĂ
        if (Item.AddedFont <> '') then
        begin
            EdtFontName.Font.Color := LblAlready.Font.Color;
            MemSample.Font.Name := Item.AddedFont;

            if Ord(Item.PostIt) > -1 then
                ToolPostIt.Buttons[Ord(Item.PostIt)].Down := true
            else
                TbNone.Down := true;                
        end
        //  ĂȂ
        else
        begin
            EdtFontName.Font.Color := LblFailed.Font.Color;
        end;
    end
    //  CXg[ς݂łȂꍇ
    else
    begin
        //  CXg[
        FTemporaryInstall := true;
        Item.Install();
        //  tHgĂ
        if (Item.AddedFont <> '') then
        begin
            EdtFontName.Font.Color := LblTemp.Font.Color;
            MemSample.Font.Name := Item.AddedFont;
            if Ord(Item.PostIt) > -1 then
                ToolPostIt.Buttons[Ord(Item.PostIt)].Down := true
            else
                TbNone.Down := true;                
        end
        //  ĂȂ
        else
        begin
            EdtFontName.Font.Color := LblFailed.Font.Color;
        end;
    end;
end;

(*
    =================================================================
    [2004/03/10]TCYύX
    =================================================================
*)
procedure TMainForm.TrackSize02Change(Sender: TObject);
begin
    FontAssignStep();
end;

(*
    =================================================================
    ÕtHg\
    =================================================================
*)
procedure   TMainForm.PrevCheckFont();
var
    Item: TFontFile;
begin
    //  `FbNpɃCXg[Ă
    if FTemporaryInstall then
    begin
        //  ЕtĂ
        Item := FFontList.GetItem(FCheckFontIndex);
        Item.UnInstall();
        FTemporaryInstall := false;
    end;
    Dec(FCheckFontIndex);
    if (FCheckFontIndex < 0) then FCheckFontIndex := LB.Count - 1;
end;

(*
    =================================================================
    ̃tHg\
    =================================================================
*)
procedure   TMainForm.NextCheckFont();
var
    Item: TFontFile;
begin
    //  `FbNpɃCXg[Ă
    if FTemporaryInstall then
    begin
        //  ЕtĂ
        Item := FFontList.GetItem(FCheckFontIndex);
        Item.UnInstall();
        FTemporaryInstall := false;
    end;
    Inc(FCheckFontIndex);
    if (FCheckFontIndex > LB.Count - 1) then FCheckFontIndex := 0;
end;


procedure TMainForm.SbPrevClick(Sender: TObject);
begin
    PrevCheckFont();
    DispCheckFont();
end;

procedure TMainForm.SbNextClick(Sender: TObject);
begin
    NextCheckFont();
    DispCheckFont();
end;

procedure TMainForm.ToolButton1Click(Sender: TObject);
var
    Item: TFontFile;
begin
    Item := FFontList.GetItem(FCheckFontIndex);
    Item.PostIt := TPostIt(TToolButton(Sender).ImageIndex);
end;

end.

